<?php

namespace Drupal\ipless;

use Drupal\Core\Render\HtmlResponse;

/**
 * IplessInterface.
 */
interface IplessInterface {

  /**
   * Check configuration and generate Less files.
   *
   * @param array $libraries
   */
  public function generate($libraries);

  /**
   * Force CSS generation.
   *
   * @param bool $value Force less compilation.
   *
   * @return \Drupal\ipless\Ipless
   */
  public function setForced($value = TRUE);

  /**
   * Flush all compiled files.
   */
  public function flushFiles();

  /**
   * Compile all Less files on HTML response.
   *
   * @param HtmlResponse $response
   */
  public function processOnResponse(HtmlResponse $response);

  /**
   * Ask for rebuild all libraries.
   */
  public function askForRebuild();

  /**
   * Compile Less file present on all libraries.
   */
  public function generateAllLibraries();

  /**
   * Return true if the libraries must be rebuild.
   *
   * @return bool
   */
  public function mustRebuildAll();

}
